#!/usr/bin/perl


#Map created by flying_popcorn
#
#License: http://creativecommons.org/licenses/by-nc-nd/3.0/
#License: http://creativecommons.org/licenses/by-nc-nd/3.0/legalcode
#
#If you host this map, please put my name somewhere (e.g. add "By flying_popcorn" in the -public or -admsg line)


print "options
-j
-ms 5
-set _wallHeight 80
-a 50 38
-mp 0,0,0,15,15,15
-set _jumpVelocity 26
-set _gravity -16
-set _noClimb 0
-set _tankSpeed 40
-c
+r
end
material
name invis
color 0 0 0 0
end
material
name grass
texture std_ground.png
end
material
name sky
color 0.7 0.7 1 1
end
mesh
vertex 400 400 40
vertex -400 400 40
vertex -400 -400 40
vertex 400 -400 40
normal 1 0 0
face
vertices 0 1 2 3
normals 0 0 0 0
        matref sky
        noradar
endface
face
vertices 3 2 1 0
normals 0 0 0 0
        matref sky
        drivethrough
        noradar
endface
end
mesh
vertex 400 400 80
vertex -400 400 80
vertex -400 -400 80
vertex 400 -400 80
face
vertices 3 2 1 0
        matref grass
        noradar
endface
end

physics
name flippedbox
linear 50 0 -999999
end

base
position 380 380 75
size 20 20 5
color 3
end

base
position 380 380 0
size 20 20 5
color 3
end

base
position -380 -380 35
size 20 20 10
color 4
end


";

for($i=0;$i<40;$i++)
{
	#make a random map
	$x=int(rand(800))-400;
	$y=int(rand(800))-400;
	$z=0;
	$xs=int(rand(38))+18;
	$ys=int(rand(38))+18;
	$zs=int(rand(22))+8;
	$type=int(rand(10));
	$rotation=int(rand(45));
	if($type<6.5){$type="box";}else{$type="pyramid";}
	
	
	if(($x>350&&$y>350)||($x<0-350&&$y<0-350)){$i--;next;}
	
	print "$type\nposition $x $y $z\nsize $xs $ys $zs\nrotation $rotation\nend\n";#make a random object
	
	#now flip the object.
	
	$z=80-$z-$zs;#new position on top
	
	print "$type\nposition $x $y $z\nsize $xs $ys $zs\nrotation $rotation\nnoradar\n";if($type eq "pyramid"){print "flipz\n";}print "end\n";
	
	if($type=="box")
	{#if they hit a box when jumping, this will send em back down.
		$z=$z-2.5;
		print "mesh\nvertex ",$x+$xs*0.8," ",$y+$ys*0.8," $z\nvertex ",$x-$xs*0.8," ",$y+$ys*0.8," $z\nvertex ",$x-$xs*0.8," ",$y-$ys*0.8," $z\nvertex ",$x+$xs*0.8," ",$y-$ys*0.8," $z\nface\nvertices 0 1 2 3\nmatref invis\nnoradar\nphydrv flippedbox\nendface\nend\n";
	}
}